diff -ruN oledrion-2.35_RC1/class/Gateways/Paypal/PaypalGateway.php oledrion-2.35_RC2/class/Gateways/Paypal/PaypalGateway.php
--- oledrion-2.35_RC1/class/Gateways/Paypal/PaypalGateway.php	2019-05-19 13:46:50.000000000 -0400
+++ oledrion-2.35_RC2/class/Gateways/Paypal/PaypalGateway.php	2019-12-14 10:25:58.585431197 -0500
@@ -181,7 +181,6 @@
         $paypal_email           = $gatewaysOptionsHandler->getGatewayOptionValue($gatewayName, 'paypal_email');
         $use_ipn                = (int)$gatewaysOptionsHandler->getGatewayOptionValue($gatewayName, 'use_ipn');
 
-        // B.R. Start
         // Need array of product_id's for optional DB update
         $caddyHandler = new Oledrion\CaddyHandler($db);
         $caddy        = $caddyHandler->getCaddyFromCommand($order->getVar('cmd_id'));
@@ -190,7 +189,6 @@
             $products[] = $item->getVar('caddy_product_id');
         }
         $product_ids = implode(',', $products);
-        // B.R. End
 
         $ret                     = [];
         $ret['cmd']              = '_xclick';
@@ -202,17 +200,15 @@
         $ret['cpp_header_image'] = XOOPS_URL . '/images/logo.gif';
         $ret['invoice']          = $order->getVar('cmd_id');
 
-        // B.R. $ret['item_name']        = _OLEDRION_COMMAND . $order->getVar('cmd_id') . ' - ' . Oledrion\Utility::makeHrefTitle($xoopsConfig['sitename']);
-        // B.R. Start
         $ret['item_name'] = $product_ids;
-        // B.R. End
 
         $ret['item_number'] = $order->getVar('cmd_id');
+        // TODO: add correct tax, add to email templates also
         $ret['tax']         = 0; // added 25/03/2008
         $ret['amount']      = $this->formatAmount((float)$order->getVar('cmd_total', 'n'));
-        $ret['custom']      = $order->getVar('cmd_id');
-        //$ret['rm'] = 2;   // Resend data by POST (normally)
-        $ret['email'] = $order->getVar('cmd_email');
+        //$ret['custom']      = $order->getVar('cmd_id');
+        $ret['email']       = $order->getVar('cmd_email');
+
         if ('' !== xoops_trim($order->getVar('cmd_cancel'))) {
             // URL to which the client's browser is brought back if the payment is canceled
             $ret['cancel_return'] = OLEDRION_URL . 'cancel-payment.php?id=' . $order->getVar('cmd_cancel');
@@ -247,19 +243,19 @@
         $db                     = \XoopsDatabaseFactory::getDatabaseConnection();
         $gatewaysOptionsHandler = new Oledrion\GatewaysOptionsHandler($db);
         $test_mode              = (int)$gatewaysOptionsHandler->getGatewayOptionValue($this->gatewayInformation['foldername'], 'paypal_test');
+
         if (1 === $test_mode) {
             return 'www.sandbox.paypal.com';
         }
-
         return 'www.paypal.com';
     }
-
     /**
      * Dialogue with the payment gateway to indicate the status of the order
      * The caller is responsible for checking that the log file exists
      *
      * @param  string $gatewaysLogPath The full path to the log file
      */
+
     public function gatewayNotify($gatewaysLogPath)
     {
         $db                     = \XoopsDatabaseFactory::getDatabaseConnection();
@@ -269,15 +265,15 @@
         error_reporting(0);
         @$xoopsLogger->activated = false;
 
-        $log     = '';
+        $log .= str_repeat('-', 80) . "\n";
         $req     = 'cmd=_notify-validate';
         $slashes = get_magic_quotes_gpc();
         foreach ($_POST as $key => $value) {
             if ($slashes) {
-                $log   .= "$key=" . stripslashes($value) . "\n";
+                //$log   .= "$key=" . stripslashes($value) . "\n";
                 $value = urlencode(stripslashes($value));
             } else {
-                $log   .= "$key=" . $value . "\n";
+                //$log   .= "$key=" . $value . "\n";
                 $value = urlencode($value);
             }
             $req .= "&$key=$value";
@@ -298,8 +294,7 @@
             fwrite($fp, "$header$req");
             while (!feof($fp)) {
                 $res = fgets($fp, 1024);
-                if (0 === strcmp(trim($res), 'VERIFIED')) {
-                    $log      .= "PAYPAL VERIFIED\n";
+                if ( 'VERIFIED' == mb_strtoupper($_POST['payer_status']) ) {
                     $paypalok = true;
                     if ('COMPLETED' !== mb_strtoupper($_POST['payment_status'])) {
                         $paypalok = false;
@@ -310,151 +305,130 @@
                     if (mb_strtoupper($_POST['mc_currency']) != mb_strtoupper($paypal_money)) {
                         $paypalok = false;
                     }
-                    if (!$_POST['custom']) {
+                    if (!$_POST['item_number']) {
                         $paypalok = false;
                     }
-                    $montant = $_POST['mc_gross'];
 
-                    //R.B. start
-                    $ref      = (int)$_POST['custom']; // Order number
+                    $montant = $_POST['mc_gross'];
+                    $ref = (int)$_POST['item_number']; // Order number
+                    $log .= sprintf("PAYPAL VERIFIED, paypalok: %d, order: %d\n", $paypalok, $ref);
                     $commande = null;
                     $commande = $commandsHandler->get($ref);
 
                     if (!is_object($commande)) {
-                        // TODO: Why is this failing?
+                        // TODO: Why is this failing? Order not exist in db
                         // TODO: Is there a more appropriate response code?
-                        //header("HTTP/1.1 500 Internal Server Error");
+                        // header("HTTP/1.1 500 Internal Server Error");
                         http_response_code(500);
-                        $log .= sprintf("not_object: %d\n", $ref);
-                        file_put_contents($gatewaysLogPath, $log, FILE_APPEND | LOCK_EX);
-
-                        return;
-                    }
-                    //R.B. end
-                    $pid = pcntl_fork();
-                    switch ($pid) {
-                        case -1:
-                            die('could not fork');
-                            break;
-                        case 0:
-                            // In the new (child) process
-
-                            // At this point, all PayPal session variables collected, done Paypal session
-                            // Rest of transaction can be processed offline to decouple site load from Paypal transaction time
-                            // PayPal requires this session to return within 30 seconds, or will retry
-                            $PayPalEndTime = microtime(true);
-                            if ($paypalok) {
-                                /* R.B. start
-                                                                $ref      = \Xmf\Request::getInt('custom', 0, 'POST'); // Numéro de la commande
-                                                                $commande = null;
-                                                                $commande = $commandsHandler->get($ref);
-                                                                if (is_object($commande)) {
-                                                                 */ //R.B. end
-
-                                if ($montant == $commande->getVar('cmd_total')) {
-                                    // Verified order
-                                    $email_name = sprintf('%s/%d%s', OLEDRION_UPLOAD_PATH, $commande->getVar('cmd_id'), OLEDRION_CONFIRMATION_EMAIL_FILENAME_SUFFIX);
-                                    if (file_exists($email_name)) {
-                                        $commandsHandler->validateOrder($commande); // Validation of the order and inventory update
-                                        $msg = [];
-                                        $msg = unserialize(file_get_contents($email_name));
-                                        // Add Transaction ID variable to email variables for templates
-                                        $msg['TRANSACTION_ID'] = $_POST['txn_id'];
-                                        // Send confirmation email to user
-                                        $email_address = $commande->getVar('cmd_email');
-                                        Oledrion\Utility::sendEmailFromTpl('command_client.tpl', $email_address, sprintf(_OLEDRION_THANKYOU_CMD, $xoopsConfig['sitename']), $msg);
-                                        // Send mail to admin
-                                        Oledrion\Utility::sendEmailFromTpl('command_shop.tpl', Oledrion\Utility::getEmailsFromGroup(Oledrion\Utility::getModuleOption('grp_sold')), _OLEDRION_NEW_COMMAND, $msg);
-
-                                        //R.B. start
-                                        // TODO: add transaction ID to SMS and online user invoice
-                                        // Update user database
-                                        if (file_exists(OLEDRION_DB_UPDATE_SCRIPT)) {
-                                            include OLEDRION_DB_UPDATE_SCRIPT;
-                                            $product_ids = $_POST['item_name'];
-                                            $products    = [];
-                                            $products    = explode(',', $product_ids);
-                                            foreach ($products as $item) {
-                                                $product_id = $item;
-                                                // updateDB($product_id, $user_id, $transaction_id);
-                                                $log .= updateDB($product_id, $_POST['receiver_email'], $_POST['txn_id']);
-                                            }
-                                        }
-                                        //R.B. end
-
-                                        if (false === @unlink($email_name)) {
-                                            throw new \RuntimeException('The file ' . $email_name . ' could not be deleted.');
-                                        }
-                                    } else {
-                                        $duplicate_ipn = 1;
+                        $log .= sprintf("is not_object: %d\n", $ref);
+			fclose($fp);
+                        return $log;
+                    }
+                    if ($paypalok) {
+                        if ($montant == $commande->getVar('cmd_total')) {
+                            // Verified order
+                            $email_name = sprintf('%s/%d%s', OLEDRION_UPLOAD_PATH, $commande->getVar('cmd_id'), OLEDRION_CONFIRMATION_EMAIL_FILENAME_SUFFIX);
+                            // Check if order exists in DB and is already validated (cmd_state=1)
+                            $sql = 'SELECT * FROM ' . $db->prefix('oledrion_commands') . ' WHERE cmd_id=' . (int)$ref . ' AND cmd_state=1';
+                            $result = $db->queryF($sql);
+                            //if ( file_exists($email_name)) {
+                            if ( $db->getRowsNum($result) == 0 ) {
+                                $commandsHandler->validateOrder($commande); // Validation of the order and inventory update
+                                $msg = [];
+                                $msg = unserialize(file_get_contents($email_name));
+                                // Add Transaction ID variable to email variables for templates
+                                $msg['TRANSACTION_ID'] = $_POST['txn_id'];
+                                $msg['NOTE'] = $commande->getVar('cmd_note');
+                                // Send confirmation email to user
+                                $email_address = $commande->getVar('cmd_email');
+                                Oledrion\Utility::sendEmailFromTpl('command_client.tpl', $email_address, sprintf(_OLEDRION_THANKYOU_CMD, $xoopsConfig['sitename']), $msg);
+                                // Send confirmation email to admin
+                                $grp_sold = Oledrion\Utility::getModuleOption('grp_sold');
+                                // Find users belonging to $grp_sold
+                                $grp_sold_user_ids = [];
+                                $sql = 'SELECT uid FROM ' . $db->prefix('groups_users_link') . ' WHERE groupid=' . $grp_sold;
+                                $result_sql = $db->queryF($sql);
+                                if ($result_sql) {
+                                    while ($myrow = $db->fetchArray($result_sql)) {
+                                        $grp_sold_user_ids[] = $myrow['uid'];
                                     }
-                                } else {
-                                    $commandsHandler->setFraudulentOrder($commande);
                                 }
-                            } else {
-                                //R.B. start
-                                // $log .= "not_object\n";
-                                //  }
-                                // } else {
-                                //R.B. end
-                                $log .= "paypal not OK\n";
-                                if (\Xmf\Request::hasVar('custom', 'POST')) {
-                                    // R.B. start
-                                    // $ref      = \Xmf\Request::getInt('custom', 0, 'POST');
-                                    // $commande = null;
-                                    // $commande = $commandsHandler->get($ref);
-                                    // if (is_object($commande)) {
-                                    //R.B. end
-                                    switch (mb_strtoupper($_POST['payment_status'])) {
-                                        case 'PENDING':
-                                            $commandsHandler->setOrderPending($commande);
-                                            break;
-                                        case 'FAILED':
-                                            $commandsHandler->setOrderFailed($commande);
-                                            break;
-                                        // R.B. }
+                                // Find emails of users belonging to $grp_sold_user_ids
+                                $admin_emails = [];
+                                $sql = 'SELECT email FROM ' . $db->prefix('users') . ' WHERE uid IN (' . implode(",", $grp_sold_user_ids) . ')';
+                                $result_sql = $db->queryF($sql);
+                                if ($result_sql) {
+                                    while ($myrow = $db->fetchArray($result_sql)) {
+                                        $admin_emails[] = $myrow['email'];
                                     }
                                 }
-                            }
-                            // Write to the log file
-                            $logfp = fopen($gatewaysLogPath, 'ab');
-                            if ($logfp) {
-                                if ($duplicate_ipn) {
-                                    fwrite($logfp, sprintf("Duplicate paypal IPN, order: %d\n", $commande->getVar('cmd_id')));
-                                } else {
-                                    fwrite($logfp, str_repeat('-', 120) . "\n");
-                                    fwrite($logfp, date('d/m/Y H:i:s') . "\n");
-                                    if (\Xmf\Request::hasVar('txn_id', 'POST')) {
-                                        fwrite($logfp, 'Transaction : ' . $_POST['txn_id'] . "\n");
+                                Oledrion\Utility::sendEmailFromTpl('command_shop.tpl', $admin_emails, _OLEDRION_NEW_COMMAND, $msg);
+                                // TODO: add transaction ID to SMS and online user invoice
+                                // Update user database
+                                if (file_exists(OLEDRION_DB_UPDATE_SCRIPT)) {
+                                    include OLEDRION_DB_UPDATE_SCRIPT;
+                                    $product_ids = $_POST['item_name'];
+                                    $products    = [];
+                                    $products    = explode(',', $product_ids);
+                                    foreach ($products as $item) {
+                                        $log .= updateDB($item, $_POST['receiver_email'], $_POST['txn_id']);
                                     }
-                                    fwrite($logfp, 'Result : ' . $log . "\n");
                                 }
-                                $executionEndTime = microtime(true);
-                                $PayPalSeconds    = $PayPalEndTime - $executionStartTime;
-                                $TotalSeconds     = $executionEndTime - $executionStartTime;
-                                fwrite($logfp, "Paypal session took $PayPalSeconds, Total transaction took $TotalSeconds seconds.\n");
-                                fclose($logfp);
-                            }
+                                if (false === @unlink($email_name)) {
+                                    $log .= "Cannot delete email: " . $_POST['txn_id'] . "\n";
+                                    throw new \RuntimeException('The file ' . $email_name . ' could not be deleted.');
+                                }
 
-                            break;
-                        default:
-                            // In the main (parent) process in which the script is running
-
-                            // At this point, all PayPal session variables collected, done Paypal session
-                            // Rest of transaction can be proccessed offline to decouple Paypal transaction time from site load
-                            // PayPal requires this session to return within 30 seconds, or will retry
 
-                            return;
-                            break;
+
+                            } else {
+                                // If transaction already complete in DB, already processed and email deleted
+                                $duplicate_ipn = 1;
+                            }
+                        } else {
+                            $log .= "Fraudulent order\n";
+                            $commandsHandler->setFraudulentOrder($commande);
+                        }
+                    } else {
+                        $log .= "Paypal not OK\n";
+                        if (\Xmf\Request::hasVar('item_number', 'POST')) {
+                            switch (mb_strtoupper($_POST['payment_status'])) {
+                                case 'PENDING':
+                                    $log .= "Order pending\n";
+                                    $commandsHandler->setOrderPending($commande);
+                                    break;
+                                case 'FAILED':
+                                    $log .= "Order failed\n";
+                                    $commandsHandler->setOrderFailed($commande);
+                                    break;
+                            }
+                        }
                     }
+                    $log .= date('d/m/Y H:i:s') . "\n";
+                    if ($duplicate_ipn) {
+                        $log .= sprintf("Duplicate paypal IPN, order: %d\n", $commande->getVar('cmd_id'));
+                    } else {
+                        if (\Xmf\Request::hasVar('txn_id', 'POST')) {
+                            $log .= 'Transaction : ' . $_POST['txn_id'] . "\n";
+                        }
+                    }                            
+                    $executionEndTime = microtime(true);
+                    $TotalSeconds     = $executionEndTime - $executionStartTime;
+                    $log       .= "Paypal transaction took $TotalSeconds seconds.\n";
+                    // PayPal requires this session to return within 30 seconds, or will retry
+                    $log .= "Dialog with payment gateway complete\n";
+                    fclose($fp); 
+                    return $log;
                 } else {
-                    $log .= "$res\n";
+                    $log .= $_POST['item_number'] . "Not Verified, _POST: " . print_r($_POST,true) . "\n";
+                    $log .= $_POST['item_number'] . "Not Verified, result: " . print_r($res,true) . "\n";
                 }
             }
             fclose($fp);
         } else {
-            $errtext = "Error with the fsockopen function, unable to open communication ' : ($errno) $errstr\n";
-            file_put_contents($gatewaysLogPath, $errtext, FILE_APPEND | LOCK_EX);
+            $log .= "Error with the fsockopen function, unable to open communication ' : ($errno) $errstr\n";
         }
+        return $log;
     }
 }
+?>
Binary files oledrion-2.35_RC1/class/Gateways/pec24.tar.gz and oledrion-2.35_RC2/class/Gateways/pec24.tar.gz differ
diff -ruN oledrion-2.35_RC1/class/Gateways.php oledrion-2.35_RC2/class/Gateways.php
--- oledrion-2.35_RC1/class/Gateways.php	2019-05-19 13:46:50.000000000 -0400
+++ oledrion-2.35_RC2/class/Gateways.php	2019-12-13 14:50:02.020939173 -0500
@@ -197,10 +197,9 @@
      */
     public static function gatewayClassName($gatewayName)
     {
-        //        return 'oledrion_' . $gatewayName;
-        return $gatewayName;
+        return 'XoopsModules\Oledrion\Gateways\\' . $gatewayName . '\\' . $gatewayName . 'Gateway';
     }
-
+ 
     /**
      * Indicates whether the payment gateway class exists
      *
@@ -209,11 +208,10 @@
      */
     public static function gatewayClassExists($gatewayName)
     {
-        $gatewayClassName = self::gatewayClassName($gatewayName);
+	$gatewayClassName = self::gatewayClassName($gatewayName);
         if (class_exists($gatewayClassName)) {
             return true;
         }
-
         return false;
     }
 
@@ -271,3 +269,4 @@
         return null;
     }
 }
+
diff -ruN oledrion-2.35_RC1/class/Products.php oledrion-2.35_RC2/class/Products.php
--- oledrion-2.35_RC1/class/Products.php	2019-05-19 13:46:50.000000000 -0400
+++ oledrion-2.35_RC2/class/Products.php	2019-12-13 14:50:02.019939584 -0500
@@ -54,11 +54,9 @@
         $this->initVar('product_thumb_url', XOBJ_DTYPE_TXTBOX, null, false);
         $this->initVar('product_submitter', XOBJ_DTYPE_INT, null, false);
         $this->initVar('product_online', XOBJ_DTYPE_INT, null, false);
-        // B.R. Start
         $this->initVar('skip_packing', XOBJ_DTYPE_INT, null, false);
         $this->initVar('skip_location', XOBJ_DTYPE_INT, null, false);
         $this->initVar('skip_delivery', XOBJ_DTYPE_INT, null, false);
-        // B.R. End
         $this->initVar('product_date', XOBJ_DTYPE_TXTBOX, null, false);
         $this->initVar('product_submitted', XOBJ_DTYPE_INT, null, false);
         $this->initVar('product_hits', XOBJ_DTYPE_INT, null, false);
@@ -354,13 +352,9 @@
         if (0 == $product_id && '' === $product_title) {
             $product_id    = $this->getVar('product_id');
             $product_title = $this->getVar('product_title', 'n');
-            // B.R. New
-            $product_url = $this->getVar('product_url3', 'n');
-            // End New
+            $product_url   = $this->getVar('product_url3', 'n');
         }
-        // B.R. New
         if (empty($product_url)) {
-            // End New
             if (1 == Oledrion\Utility::getModuleOption('urlrewriting')) {
                 // On utilise l'url rewriting
                 if (!$shortVersion) {
@@ -376,11 +370,9 @@
                     $url = 'product.php?product_id=' . $product_id;
                 }
             }
-            // B.R. New
         } else {
             $url = '../' . $product_url;
         }
-        // B.R. End New
         return $url;
     }
 
diff -ruN oledrion-2.35_RC1/class/Reductions.php oledrion-2.35_RC2/class/Reductions.php
--- oledrion-2.35_RC1/class/Reductions.php	2019-05-19 13:46:50.000000000 -0400
+++ oledrion-2.35_RC2/class/Reductions.php	2019-12-13 14:50:02.043929730 -0500
@@ -103,9 +103,6 @@
     // Montant total de la commande avant les réductions
     private $totalAmountBeforeDiscounts = 0;
 
-    // Handlers vers les tables du module
-    //    private $handlers;
-
     // Les fabricants associés aux produits du panier
     private $associatedManufacturers = [];
 
@@ -126,17 +123,12 @@
      */
     public function __construct()
     {
-        $this->initHandlers();
         $this->loadAllActiveRules();
     }
 
     /**
      * Chargement des handlers
      */
-    private function initHandlers()
-    {
-        //        $this->handlers = HandlerManager::getInstance();
-    }
 
     /**
      * Chargement de toutes les règles actives de réductions (sans date définie ou avec une période correspondante à aujourd'hui)
@@ -156,8 +148,6 @@
         $critere2->add(new \Criteria('disc_date_to', time(), '>='));
         $critere->add($critere2, 'OR');
 
-        //        $this->allActiveRules = $this->handlers->h_oledrion_discounts->getObjects($critere);
-        //        $this->allActiveRules = $this->handlers->DiscountsHandler->getObjects($critere);
         $discountsHandler     = new Oledrion\DiscountsHandler($xoopsDB);
         $this->allActiveRules = $discountsHandler->getObjects($critere);
     }
@@ -290,7 +280,6 @@
         if (count($this->associatedCategories) > 0) {
             sort($this->associatedCategories);
             $ids = $this->associatedCategories;
-            //mb            $this->associatedCategories = $this->handlers->h_oledrion_cat->getCategoriesFromIds($ids);
             $db                         = \XoopsDatabaseFactory::getDatabaseConnection();
             $categoryHandler            = new Oledrion\CategoryHandler($db);
             $this->associatedCategories = $categoryHandler->getCategoriesFromIds($ids);
@@ -406,14 +395,13 @@
      * @param float  $commandAmountTTC      Montant TTC de la commande
      * @param array  $discountsDescription  Descriptions des remises GLOBALES appliquées (et pas les remises par produit !)
      * @param int    $discountsCount        Le nombre TOTAL de réductions appliquées (individuellement ou sur la globalité du panier)
-     *                                      B.R. @param array $checkoutAttributes
+     *                                      @param array $checkoutAttributes
      *                                      TODO: Passer les paramètres sous forme d'objet
      * @param mixed  $emptyCart
      * @param mixed  $checkoutAttributes
      * @return bool
      */
 
-    // B.R. Added: $checkoutAttributes
     public function computeCart(
         &$cartForTemplate,
         &$emptyCart,
@@ -424,7 +412,7 @@
         &$commandAmountTTC,
         &$discountsDescription,
         &$discountsCount,
-        &$checkoutAttributes)// B.R.
+        &$checkoutAttributes)
 
     {
         $emptyCart      = false;
@@ -484,7 +472,6 @@
             $totalPrice = 0.0;
             $reduction  = '';
 
-            // B.R. Start
             // If any product in cart does not skip optional checkout step, need to perform
             if (0 == $cartProduct['product']->getVar('skip_packing', 'n')) {
                 $checkoutAttributes['skip_packing'] = 0;
@@ -495,13 +482,11 @@
             if (0 == $cartProduct['product']->getVar('skip_delivery', 'n')) {
                 $checkoutAttributes['skip_delivery'] = 0;
             }
-            // B.R. End
 
             ++$cpt;
             if ($cpt == $caddyCount) {
                 // On arrive sur le dernier produit
                 $category = null;
-                //mb                $category = $this->handlers->h_oledrion_cat->get($cartProduct['product']->getVar('product_cid'));
                 $category = $categoryHandler->get($cartProduct['product']->getVar('product_cid'));
                 if (is_object($category)) {
                     $goOn = $category->getLink();
@@ -756,7 +741,6 @@
             $productTemplate['discountedPriceWithQuantityFormated'] = $oledrionCurrency->amountForDisplay($discountedPrice * $quantity);
             // Prix HT AVEC réduction et la quantité
 
-            // Add by voltan
             $productTemplate['discountedPriceFormatedOrg'] = $oledrionCurrency->amountForDisplay($ht - $discountedPrice);
             $productTemplate['discountedPriceOrg']         = $ht - $discountedPrice;
 
